
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 31 "policy_parse.y"

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

typedef int (* require_func_t)();



/* Line 189 of yacc.c  */
#line 111 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PATH = 258,
     CLONE = 259,
     COMMON = 260,
     CLASS = 261,
     CONSTRAIN = 262,
     VALIDATETRANS = 263,
     INHERITS = 264,
     SID = 265,
     ROLE = 266,
     ROLES = 267,
     TYPEALIAS = 268,
     TYPEATTRIBUTE = 269,
     TYPEBOUNDS = 270,
     TYPE = 271,
     TYPES = 272,
     ALIAS = 273,
     ATTRIBUTE = 274,
     BOOL = 275,
     IF = 276,
     ELSE = 277,
     TYPE_TRANSITION = 278,
     TYPE_MEMBER = 279,
     TYPE_CHANGE = 280,
     ROLE_TRANSITION = 281,
     RANGE_TRANSITION = 282,
     SENSITIVITY = 283,
     DOMINANCE = 284,
     DOM = 285,
     DOMBY = 286,
     INCOMP = 287,
     CATEGORY = 288,
     LEVEL = 289,
     RANGE = 290,
     MLSCONSTRAIN = 291,
     MLSVALIDATETRANS = 292,
     USER = 293,
     NEVERALLOW = 294,
     ALLOW = 295,
     AUDITALLOW = 296,
     AUDITDENY = 297,
     DONTAUDIT = 298,
     SOURCE = 299,
     TARGET = 300,
     SAMEUSER = 301,
     FSCON = 302,
     PORTCON = 303,
     NETIFCON = 304,
     NODECON = 305,
     FSUSEXATTR = 306,
     FSUSETASK = 307,
     FSUSETRANS = 308,
     GENFSCON = 309,
     U1 = 310,
     U2 = 311,
     U3 = 312,
     R1 = 313,
     R2 = 314,
     R3 = 315,
     T1 = 316,
     T2 = 317,
     T3 = 318,
     L1 = 319,
     L2 = 320,
     H1 = 321,
     H2 = 322,
     NOT = 323,
     AND = 324,
     OR = 325,
     XOR = 326,
     CTRUE = 327,
     CFALSE = 328,
     IDENTIFIER = 329,
     NUMBER = 330,
     EQUALS = 331,
     NOTEQUAL = 332,
     IPV4_ADDR = 333,
     IPV6_ADDR = 334,
     MODULE = 335,
     VERSION_IDENTIFIER = 336,
     REQUIRE = 337,
     OPTIONAL = 338,
     POLICYCAP = 339,
     PERMISSIVE = 340
   };
#endif
/* Tokens.  */
#define PATH 258
#define CLONE 259
#define COMMON 260
#define CLASS 261
#define CONSTRAIN 262
#define VALIDATETRANS 263
#define INHERITS 264
#define SID 265
#define ROLE 266
#define ROLES 267
#define TYPEALIAS 268
#define TYPEATTRIBUTE 269
#define TYPEBOUNDS 270
#define TYPE 271
#define TYPES 272
#define ALIAS 273
#define ATTRIBUTE 274
#define BOOL 275
#define IF 276
#define ELSE 277
#define TYPE_TRANSITION 278
#define TYPE_MEMBER 279
#define TYPE_CHANGE 280
#define ROLE_TRANSITION 281
#define RANGE_TRANSITION 282
#define SENSITIVITY 283
#define DOMINANCE 284
#define DOM 285
#define DOMBY 286
#define INCOMP 287
#define CATEGORY 288
#define LEVEL 289
#define RANGE 290
#define MLSCONSTRAIN 291
#define MLSVALIDATETRANS 292
#define USER 293
#define NEVERALLOW 294
#define ALLOW 295
#define AUDITALLOW 296
#define AUDITDENY 297
#define DONTAUDIT 298
#define SOURCE 299
#define TARGET 300
#define SAMEUSER 301
#define FSCON 302
#define PORTCON 303
#define NETIFCON 304
#define NODECON 305
#define FSUSEXATTR 306
#define FSUSETASK 307
#define FSUSETRANS 308
#define GENFSCON 309
#define U1 310
#define U2 311
#define U3 312
#define R1 313
#define R2 314
#define R3 315
#define T1 316
#define T2 317
#define T3 318
#define L1 319
#define L2 320
#define H1 321
#define H2 322
#define NOT 323
#define AND 324
#define OR 325
#define XOR 326
#define CTRUE 327
#define CFALSE 328
#define IDENTIFIER 329
#define NUMBER 330
#define EQUALS 331
#define NOTEQUAL 332
#define IPV4_ADDR 333
#define IPV6_ADDR 334
#define MODULE 335
#define VERSION_IDENTIFIER 336
#define REQUIRE 337
#define OPTIONAL 338
#define POLICYCAP 339
#define PERMISSIVE 340




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 68 "policy_parse.y"

	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;



/* Line 214 of yacc.c  */
#line 326 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 338 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   935

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  96
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  160
/* YYNRULES -- Number of rules.  */
#define YYNRULES  317
/* YYNRULES -- Number of states.  */
#define YYNSTATES  633

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   340

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      91,    92,    95,     2,    90,    93,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    89,    88,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    86,     2,    87,    94,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     8,     9,    10,    26,    28,
      31,    34,    36,    39,    42,    45,    47,    48,    50,    53,
      59,    61,    64,    70,    75,    83,    85,    86,    92,    94,
      97,   102,   106,   109,   112,   117,   119,   120,   122,   125,
     130,   134,   136,   139,   145,   149,   151,   154,   156,   158,
     164,   169,   171,   174,   176,   178,   180,   182,   184,   186,
     188,   190,   192,   194,   196,   198,   200,   202,   204,   206,
     208,   210,   212,   214,   218,   224,   229,   234,   239,   244,
     247,   248,   253,   255,   257,   264,   269,   270,   274,   277,
     281,   285,   289,   293,   297,   299,   301,   304,   305,   307,
     309,   311,   319,   327,   335,   337,   339,   341,   343,   351,
     359,   367,   375,   383,   391,   399,   405,   413,   415,   417,
     419,   421,   423,   431,   439,   447,   455,   463,   469,   473,
     478,   484,   489,   491,   494,   498,   504,   506,   507,   509,
     512,   514,   516,   522,   527,   531,   534,   538,   542,   544,
     548,   552,   556,   557,   562,   563,   568,   569,   574,   575,
     580,   581,   586,   587,   592,   593,   598,   599,   604,   605,
     610,   612,   613,   618,   619,   624,   627,   628,   633,   634,
     639,   643,   647,   651,   655,   659,   663,   665,   667,   669,
     671,   673,   675,   677,   680,   687,   692,   693,   695,   698,
     702,   704,   705,   707,   710,   716,   720,   722,   723,   725,
     728,   733,   740,   742,   743,   745,   748,   753,   755,   756,
     758,   761,   766,   771,   773,   774,   776,   779,   784,   789,
     794,   796,   797,   799,   802,   809,   810,   818,   823,   825,
     832,   835,   836,   840,   842,   846,   848,   850,   854,   856,
     858,   860,   862,   864,   867,   870,   871,   876,   878,   880,
     882,   886,   888,   891,   896,   898,   901,   903,   905,   908,
     912,   914,   917,   919,   920,   924,   926,   928,   930,   932,
     934,   938,   942,   945,   950,   952,   954,   957,   960,   962,
     964,   966,   968,   970,   972,   974,   979,   982,   984,   987,
     991,   995,   997,   999,  1001,  1003,  1005,  1007,  1009,  1011,
    1015,  1016,  1023,  1028,  1029,  1031,  1033,  1036
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      97,     0,    -1,    98,    -1,   238,    -1,    -1,    -1,    -1,
      99,   102,   104,   106,   100,   112,   127,   187,   165,   101,
     190,   192,   205,   208,   195,    -1,   103,    -1,   102,   103,
      -1,     6,   232,    -1,   105,    -1,   104,   105,    -1,    10,
     232,    -1,   107,   110,    -1,   108,    -1,    -1,   109,    -1,
     108,   109,    -1,     5,   232,    86,   227,    87,    -1,   111,
      -1,   110,   111,    -1,     6,   232,    86,   227,    87,    -1,
       6,   232,     9,   232,    -1,     6,   232,     9,   232,    86,
     227,    87,    -1,   113,    -1,    -1,   114,   117,   118,   121,
     123,    -1,   115,    -1,   114,   115,    -1,    28,   232,   116,
      88,    -1,    28,   232,    88,    -1,    18,   220,    -1,    29,
     232,    -1,    29,    86,   227,    87,    -1,   119,    -1,    -1,
     120,    -1,   119,   120,    -1,    33,   232,   116,    88,    -1,
      33,   232,    88,    -1,   122,    -1,   121,   122,    -1,    34,
     232,    89,   217,    88,    -1,    34,   232,    88,    -1,   124,
      -1,   123,   124,    -1,   125,    -1,   126,    -1,    36,   220,
     220,   170,    88,    -1,    37,   220,   170,    88,    -1,   128,
      -1,   127,   128,    -1,   130,    -1,   129,    -1,   139,    -1,
     250,    -1,   236,    -1,    88,    -1,   159,    -1,   160,    -1,
     161,    -1,   162,    -1,   131,    -1,   132,    -1,   133,    -1,
     134,    -1,   135,    -1,   137,    -1,   151,    -1,   152,    -1,
     153,    -1,   237,    -1,    19,   232,    88,    -1,    16,   232,
     116,   136,    88,    -1,    16,   232,   136,    88,    -1,    13,
     232,   116,    88,    -1,    14,   232,   217,    88,    -1,    15,
     232,   217,    88,    -1,    90,   217,    -1,    -1,    20,   232,
     138,    88,    -1,    72,    -1,    73,    -1,    21,   141,    86,
     143,    87,   140,    -1,    22,    86,   143,    87,    -1,    -1,
      91,   141,    92,    -1,    68,   141,    -1,   141,    69,   141,
      -1,   141,    70,   141,    -1,   141,    71,   141,    -1,   141,
      76,   141,    -1,   141,    77,   141,    -1,   142,    -1,   232,
      -1,   143,   144,    -1,    -1,   145,    -1,   146,    -1,   244,
      -1,    23,   220,   220,    89,   220,   232,    88,    -1,    24,
     220,   220,    89,   220,   232,    88,    -1,    25,   220,   220,
      89,   220,   232,    88,    -1,   147,    -1,   148,    -1,   149,
      -1,   150,    -1,    40,   220,   220,    89,   220,   220,    88,
      -1,    41,   220,   220,    89,   220,   220,    88,    -1,    42,
     220,   220,    89,   220,   220,    88,    -1,    43,   220,   220,
      89,   220,   220,    88,    -1,    23,   220,   220,    89,   220,
     232,    88,    -1,    24,   220,   220,    89,   220,   232,    88,
      -1,    25,   220,   220,    89,   220,   232,    88,    -1,    27,
     220,   220,   215,    88,    -1,    27,   220,   220,    89,   220,
     215,    88,    -1,   154,    -1,   155,    -1,   156,    -1,   157,
      -1,   158,    -1,    40,   220,   220,    89,   220,   220,    88,
      -1,    41,   220,   220,    89,   220,   220,    88,    -1,    42,
     220,   220,    89,   220,   220,    88,    -1,    43,   220,   220,
      89,   220,   220,    88,    -1,    39,   220,   220,    89,   220,
     220,    88,    -1,    11,   232,    17,   220,    88,    -1,    11,
     232,    88,    -1,    29,    86,   163,    87,    -1,    26,   220,
     220,   232,    88,    -1,    40,   220,   220,    88,    -1,   164,
      -1,   163,   164,    -1,    11,   226,    88,    -1,    11,   226,
      86,   163,    87,    -1,   166,    -1,    -1,   167,    -1,   166,
     167,    -1,   168,    -1,   169,    -1,     7,   220,   220,   170,
      88,    -1,     8,   220,   170,    88,    -1,    91,   170,    92,
      -1,    68,   170,    -1,   170,    69,   170,    -1,   170,    70,
     170,    -1,   171,    -1,    55,   185,    56,    -1,    58,   186,
      59,    -1,    61,   185,    62,    -1,    -1,    55,   185,   172,
     224,    -1,    -1,    56,   185,   173,   224,    -1,    -1,    57,
     185,   174,   224,    -1,    -1,    58,   185,   175,   224,    -1,
      -1,    59,   185,   176,   224,    -1,    -1,    60,   185,   177,
     224,    -1,    -1,    61,   185,   178,   224,    -1,    -1,    62,
     185,   179,   224,    -1,    -1,    63,   185,   180,   224,    -1,
      46,    -1,    -1,    44,    11,   181,   224,    -1,    -1,    45,
      11,   182,   224,    -1,    11,   186,    -1,    -1,    44,    16,
     183,   224,    -1,    -1,    45,    16,   184,   224,    -1,    64,
     186,    65,    -1,    64,   186,    67,    -1,    66,   186,    65,
      -1,    66,   186,    67,    -1,    64,   186,    66,    -1,    65,
     186,    67,    -1,    76,    -1,    77,    -1,   185,    -1,    30,
      -1,    31,    -1,    32,    -1,   188,    -1,   187,   188,    -1,
      38,   232,    12,   220,   189,    88,    -1,    34,   216,    35,
     215,    -1,    -1,   191,    -1,   190,   191,    -1,    10,   232,
     213,    -1,   193,    -1,    -1,   194,    -1,   193,   194,    -1,
      47,   234,   234,   213,   213,    -1,   196,   199,   202,    -1,
     197,    -1,    -1,   198,    -1,   197,   198,    -1,    48,   232,
     234,   213,    -1,    48,   232,   234,    93,   234,   213,    -1,
     200,    -1,    -1,   201,    -1,   200,   201,    -1,    49,   232,
     213,   213,    -1,   203,    -1,    -1,   204,    -1,   203,   204,
      -1,    50,   212,   212,   213,    -1,    50,   235,   235,   213,
      -1,   206,    -1,    -1,   207,    -1,   206,   207,    -1,    51,
     232,   213,    88,    -1,    52,   232,   213,    88,    -1,    53,
     232,   213,    88,    -1,   209,    -1,    -1,   210,    -1,   209,
     210,    -1,    54,   232,   233,    93,   232,   213,    -1,    -1,
      54,   232,   233,    93,    93,   211,   213,    -1,    54,   232,
     233,   213,    -1,    78,    -1,   232,    89,   232,    89,   232,
     214,    -1,    89,   215,    -1,    -1,   216,    93,   216,    -1,
     216,    -1,   232,    89,   217,    -1,   232,    -1,   232,    -1,
     217,    90,   232,    -1,    94,    -1,    95,    -1,   232,    -1,
     228,    -1,   219,    -1,   218,   232,    -1,   218,   228,    -1,
      -1,   232,    93,   221,   232,    -1,   218,    -1,   219,    -1,
     226,    -1,    86,   225,    87,    -1,   223,    -1,   222,   226,
      -1,   222,    86,   225,    87,    -1,   226,    -1,   225,   226,
      -1,    74,    -1,   232,    -1,   227,   232,    -1,    86,   229,
      87,    -1,   230,    -1,   229,   230,    -1,   232,    -1,    -1,
      93,   231,   232,    -1,   228,    -1,    74,    -1,     3,    -1,
      75,    -1,    79,    -1,    84,   232,    88,    -1,    85,   232,
      88,    -1,   239,   241,    -1,    80,   232,   240,    88,    -1,
      81,    -1,   212,    -1,   242,   255,    -1,   242,   243,    -1,
     243,    -1,   129,    -1,   130,    -1,   139,    -1,   244,    -1,
     250,    -1,    88,    -1,    82,    86,   245,    87,    -1,   245,
     246,    -1,   246,    -1,   247,    88,    -1,   248,   249,    88,
      -1,     6,   232,   220,    -1,    11,    -1,    16,    -1,    19,
      -1,    38,    -1,    20,    -1,    28,    -1,    33,    -1,   232,
      -1,   249,    90,   232,    -1,    -1,   253,    86,   241,    87,
     251,   252,    -1,   254,    86,   241,    87,    -1,    -1,    83,
      -1,    22,    -1,   188,   255,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   147,   147,   148,   150,   152,   155,   150,   159,   160,
     162,   165,   166,   168,   171,   173,   174,   176,   177,   179,
     182,   183,   185,   187,   189,   192,   193,   195,   197,   198,
     200,   202,   205,   207,   209,   212,   213,   215,   216,   218,
     220,   223,   224,   226,   228,   231,   232,   234,   235,   237,
     240,   243,   244,   246,   247,   248,   249,   250,   251,   253,
     254,   255,   256,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   269,   272,   274,   277,   280,   283,   286,
     287,   289,   292,   294,   297,   300,   303,   304,   306,   309,
     312,   315,   318,   321,   324,   327,   331,   334,   336,   338,
     340,   343,   346,   349,   353,   355,   357,   359,   362,   366,
     370,   374,   378,   380,   382,   385,   387,   390,   391,   392,
     393,   394,   396,   399,   402,   405,   408,   411,   413,   416,
     418,   421,   424,   426,   429,   431,   434,   435,   437,   438,
     440,   441,   443,   446,   449,   451,   454,   457,   460,   463,
     466,   469,   472,   472,   475,   475,   478,   478,   481,   481,
     484,   484,   487,   487,   490,   490,   493,   493,   496,   496,
     499,   502,   502,   505,   505,   508,   511,   511,   514,   514,
     517,   520,   523,   526,   529,   532,   536,   538,   541,   543,
     545,   547,   550,   551,   553,   556,   557,   559,   560,   562,
     565,   566,   568,   569,   571,   574,   576,   577,   579,   580,
     582,   584,   587,   588,   590,   591,   593,   596,   597,   599,
     600,   602,   604,   607,   608,   610,   611,   613,   615,   617,
     620,   621,   623,   624,   626,   628,   628,   630,   633,   636,
     638,   639,   641,   643,   646,   648,   651,   652,   654,   656,
     658,   660,   662,   665,   668,   671,   671,   674,   677,   680,
     681,   682,   683,   684,   686,   687,   689,   692,   693,   695,
     697,   697,   699,   699,   699,   699,   701,   704,   707,   710,
     713,   716,   721,   726,   729,   731,   733,   735,   736,   738,
     739,   740,   741,   742,   743,   745,   747,   748,   750,   751,
     753,   756,   757,   758,   759,   760,   761,   762,   764,   766,
     770,   769,   774,   776,   778,   781,   784,   785
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "CLONE", "COMMON", "CLASS",
  "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID", "ROLE", "ROLES",
  "TYPEALIAS", "TYPEATTRIBUTE", "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS",
  "ATTRIBUTE", "BOOL", "IF", "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER",
  "TYPE_CHANGE", "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY",
  "DOMINANCE", "DOM", "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE",
  "MLSCONSTRAIN", "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW",
  "AUDITALLOW", "AUDITDENY", "DONTAUDIT", "SOURCE", "TARGET", "SAMEUSER",
  "FSCON", "PORTCON", "NETIFCON", "NODECON", "FSUSEXATTR", "FSUSETASK",
  "FSUSETRANS", "GENFSCON", "U1", "U2", "U3", "R1", "R2", "R3", "T1", "T2",
  "T3", "L1", "L2", "H1", "H2", "NOT", "AND", "OR", "XOR", "CTRUE",
  "CFALSE", "IDENTIFIER", "NUMBER", "EQUALS", "NOTEQUAL", "IPV4_ADDR",
  "IPV6_ADDR", "MODULE", "VERSION_IDENTIFIER", "REQUIRE", "OPTIONAL",
  "POLICYCAP", "PERMISSIVE", "'{'", "'}'", "';'", "':'", "','", "'('",
  "')'", "'-'", "'~'", "'*'", "$accept", "policy", "base_policy", "$@1",
  "$@2", "$@3", "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_mls", "mls", "sensitivities",
  "sensitivity_def", "alias_def", "dominance", "opt_categories",
  "categories", "category_def", "levels", "level_def", "mlspolicy",
  "mlspolicy_decl", "mlsconstraint_def", "mlsvalidatetrans_def", "te_rbac",
  "te_rbac_decl", "rbac_decl", "te_decl", "attribute_def", "type_def",
  "typealias_def", "typeattribute_def", "typebounds_def", "opt_attr_list",
  "bool_def", "bool_val", "cond_stmt_def", "cond_else", "cond_expr",
  "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "role_type_def", "role_dominance", "role_trans_def", "role_allow_def",
  "roles", "role_def", "opt_constraints", "constraints", "constraint_decl",
  "constraint_def", "validatetrans_def", "cexpr", "cexpr_prim", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "op", "role_mls_op", "users", "user_def",
  "opt_mls_user", "initial_sid_contexts", "initial_sid_context_def",
  "opt_fs_contexts", "fs_contexts", "fs_context_def", "net_contexts",
  "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "security_context_def",
  "opt_mls_range_def", "mls_range_def", "mls_level_def", "id_comma_list",
  "tilde", "asterisk", "names", "$@18", "tilde_push", "asterisk_push",
  "names_push", "identifier_list_push", "identifier_push",
  "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@19", "identifier", "path", "number", "ipv6_addr",
  "policycap_def", "permissive_def", "module_policy", "module_def",
  "version_identifier", "avrules_block", "avrule_decls", "avrule_decl",
  "require_block", "require_list", "require_decl", "require_class",
  "require_decl_def", "require_id_list", "optional_block", "$@20",
  "optional_else", "optional_decl", "else_decl", "avrule_user_defs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   123,   125,    59,    58,
      44,    40,    41,    45,   126,    42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    96,    97,    97,    99,   100,   101,    98,   102,   102,
     103,   104,   104,   105,   106,   107,   107,   108,   108,   109,
     110,   110,   111,   111,   111,   112,   112,   113,   114,   114,
     115,   115,   116,   117,   117,   118,   118,   119,   119,   120,
     120,   121,   121,   122,   122,   123,   123,   124,   124,   125,
     126,   127,   127,   128,   128,   128,   128,   128,   128,   129,
     129,   129,   129,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   131,   132,   132,   133,   134,   135,   136,
     136,   137,   138,   138,   139,   140,   140,   141,   141,   141,
     141,   141,   141,   141,   141,   142,   143,   143,   144,   144,
     144,   145,   145,   145,   146,   146,   146,   146,   147,   148,
     149,   150,   151,   151,   151,   152,   152,   153,   153,   153,
     153,   153,   154,   155,   156,   157,   158,   159,   159,   160,
     161,   162,   163,   163,   164,   164,   165,   165,   166,   166,
     167,   167,   168,   169,   170,   170,   170,   170,   170,   171,
     171,   171,   172,   171,   173,   171,   174,   171,   175,   171,
     176,   171,   177,   171,   178,   171,   179,   171,   180,   171,
     171,   181,   171,   182,   171,   171,   183,   171,   184,   171,
     171,   171,   171,   171,   171,   171,   185,   185,   186,   186,
     186,   186,   187,   187,   188,   189,   189,   190,   190,   191,
     192,   192,   193,   193,   194,   195,   196,   196,   197,   197,
     198,   198,   199,   199,   200,   200,   201,   202,   202,   203,
     203,   204,   204,   205,   205,   206,   206,   207,   207,   207,
     208,   208,   209,   209,   210,   211,   210,   210,   212,   213,
     214,   214,   215,   215,   216,   216,   217,   217,   218,   219,
     220,   220,   220,   220,   220,   221,   220,   222,   223,   224,
     224,   224,   224,   224,   225,   225,   226,   227,   227,   228,
     229,   229,   230,   231,   230,   230,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   240,   241,   242,   242,   243,
     243,   243,   243,   243,   243,   244,   245,   245,   246,   246,
     247,   248,   248,   248,   248,   248,   248,   248,   249,   249,
     251,   250,   252,   252,   253,   254,   255,   255
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    15,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     5,     1,     2,
       4,     3,     2,     2,     4,     1,     0,     1,     2,     4,
       3,     1,     2,     5,     3,     1,     2,     1,     1,     5,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     4,     4,     4,     4,     2,
       0,     4,     1,     1,     6,     4,     0,     3,     2,     3,
       3,     3,     3,     3,     1,     1,     2,     0,     1,     1,
       1,     7,     7,     7,     1,     1,     1,     1,     7,     7,
       7,     7,     7,     7,     7,     5,     7,     1,     1,     1,
       1,     1,     7,     7,     7,     7,     7,     5,     3,     4,
       5,     4,     1,     2,     3,     5,     1,     0,     1,     2,
       1,     1,     5,     4,     3,     2,     3,     3,     1,     3,
       3,     3,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       1,     0,     4,     0,     4,     2,     0,     4,     0,     4,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     4,     0,     1,     2,     3,
       1,     0,     1,     2,     5,     3,     1,     0,     1,     2,
       4,     6,     1,     0,     1,     2,     4,     1,     0,     1,
       2,     4,     4,     1,     0,     1,     2,     4,     4,     4,
       1,     0,     1,     2,     6,     0,     7,     4,     1,     6,
       2,     0,     3,     1,     3,     1,     1,     3,     1,     1,
       1,     1,     1,     2,     2,     0,     4,     1,     1,     1,
       3,     1,     2,     4,     1,     2,     1,     1,     2,     3,
       1,     2,     1,     0,     3,     1,     1,     1,     1,     1,
       3,     3,     2,     4,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     4,     2,     1,     2,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       0,     6,     4,     0,     1,     1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   276,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   314,     0,   294,   289,   290,    63,    64,
      65,    66,    67,    68,   291,    69,    70,    71,   117,   118,
     119,   120,   121,    59,    60,    61,    62,    72,   282,   317,
     288,   292,   293,     0,   238,   284,   285,     0,    10,     0,
       9,    16,    11,     0,     0,     0,     0,    80,     0,     0,
       0,     0,     0,    94,    95,     0,   248,   249,     0,   252,
       0,   251,   250,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   317,   287,   286,     0,
     283,    13,     0,    12,     5,     0,    15,    17,     0,   128,
       0,     0,     0,   246,     0,     0,    80,     0,    73,    82,
      83,     0,    88,     0,     0,     0,     0,     0,     0,    97,
     273,   275,     0,   270,   272,   254,   253,     0,   255,     0,
       0,     0,     0,     0,     0,   132,     0,     0,     0,     0,
       0,     0,   301,   302,   303,   305,   306,   307,   304,     0,
     297,     0,     0,   281,     0,   316,     0,     0,    26,     0,
      14,    20,    18,     0,    32,    76,    77,     0,    78,    79,
       0,    75,    81,    87,    89,    90,    91,    92,    93,     0,
       0,   269,   271,     0,     0,     0,     0,     0,     0,     0,
     243,   245,   266,     0,   129,   133,     0,   131,     0,     0,
       0,     0,     0,   295,   296,   298,   308,     0,     0,   310,
       0,     0,     0,    25,     0,    28,     0,    21,   127,   247,
      74,     0,     0,     0,     0,     0,     0,     0,    86,    96,
      98,    99,   104,   105,   106,   107,   100,   274,     0,   256,
       0,     0,   130,     0,   115,     0,     0,     0,   134,     0,
       0,     0,     0,     0,   300,   299,     0,   196,   313,     0,
     267,     0,     0,    58,     0,    51,    54,    53,    55,    57,
      56,     0,    29,    36,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,     0,     0,     0,     0,   242,
     244,     0,     0,     0,     0,     0,     0,   309,     0,     0,
     315,   311,     0,    19,   268,    31,     0,     0,    52,   137,
     192,     0,    33,     0,     0,    35,    37,    23,     0,     0,
       0,     0,     0,     0,     0,     0,    97,   112,   113,   114,
     116,   135,   126,   122,   123,   124,   125,     0,   194,     0,
      30,   280,     0,     0,     6,   136,   138,   140,   141,   193,
       0,     0,     0,     0,    41,    38,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   139,    34,    40,     0,     0,     0,     0,    42,    27,
      45,    47,    48,     0,     0,     0,     0,     0,     0,     0,
       0,    85,   195,   312,     0,     0,     0,     0,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   148,     0,   201,   197,    39,    44,
       0,     0,     0,    46,    24,     0,     0,     0,     0,     0,
       0,     0,     0,   189,   190,   191,   186,   187,   188,   175,
     171,   176,   173,   178,   152,   154,   156,   158,     0,   160,
     162,   164,   166,   168,     0,     0,     0,   145,     0,     0,
       0,   143,     0,     0,   198,   224,   200,   202,     0,     0,
       0,   101,   102,   103,   108,   109,   110,   111,   142,     0,
       0,     0,     0,   149,     0,     0,     0,     0,   150,     0,
       0,   151,     0,     0,     0,   180,   184,   181,   185,   182,
     183,   144,   146,   147,   199,     0,   278,     0,     0,     0,
       0,   231,   223,   225,   203,    43,     0,    50,     0,   257,
     258,     0,   261,   172,   259,   177,   174,   179,   153,   155,
     157,   159,   161,   163,   165,   167,   169,     0,     0,     0,
       0,     0,     0,   207,   230,   232,   226,    49,     0,   264,
       0,   262,     0,     0,     0,     0,     0,     0,     0,     7,
     213,   206,   208,   233,   260,   265,     0,     0,   204,   227,
     228,   229,   277,     0,     0,     0,   218,   212,   214,   209,
     263,   241,     0,   237,     0,     0,     0,   205,   217,   219,
     215,     0,   239,   235,     0,     0,   210,     0,   279,     0,
       0,   220,   240,     0,   234,     0,   216,     0,     0,   236,
     211,   221,   222
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   178,   390,    11,    12,    71,    72,
     114,   115,   116,   117,   180,   181,   232,   233,   234,   235,
     121,   293,   334,   335,   336,   373,   374,   399,   400,   401,
     402,   284,   285,    36,    37,    38,    39,    40,    41,    42,
     127,    43,   131,    44,   304,    82,    83,   199,   249,   250,
     251,   252,   253,   254,   255,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,   154,   155,   364,
     365,   366,   367,   368,   433,   434,   504,   505,   506,   507,
     509,   510,   512,   513,   514,   499,   501,   500,   502,   458,
     459,   329,   106,   319,   436,   437,   485,   486,   487,   579,
     580,   581,   582,   596,   597,   598,   607,   608,   609,   531,
     532,   533,   563,   564,   565,   623,    66,   524,   612,   209,
     210,   122,    88,    89,    90,   204,   541,   542,   543,   568,
     544,   279,    91,   142,   143,   200,    92,   593,   527,   620,
     289,    57,     5,     6,    67,    58,    59,    60,    61,   169,
     170,   171,   172,   227,    62,   278,   321,    63,   322,   108
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -518
static const yytype_int16 yypact[] =
{
     -41,   -14,    91,  -518,    99,  -518,   760,  -518,   204,  -518,
     -14,   281,  -518,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
     -13,    87,    87,    87,    87,    87,    41,    87,    87,    87,
      87,    87,    97,  -518,   -14,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,   417,
    -518,  -518,  -518,   111,  -518,  -518,  -518,   118,  -518,   -14,
    -518,    90,  -518,    13,   216,   -14,   -14,     7,   149,    48,
     -13,   -13,   200,  -518,  -518,   187,  -518,  -518,   -37,  -518,
      87,  -518,   159,    87,    87,    87,    87,   256,    87,    87,
      87,    87,    87,   230,   215,   -14,   254,  -518,  -518,   760,
    -518,  -518,   -14,  -518,  -518,   282,   306,  -518,    87,  -518,
      87,   255,   184,  -518,   243,   -14,   238,   260,  -518,  -518,
    -518,   269,    82,   162,   -13,   -13,   -13,   -13,   -13,  -518,
    -518,  -518,    69,  -518,  -518,  -518,  -518,   271,  -518,   275,
     297,   -14,   -27,   296,     9,  -518,   304,    80,   307,   308,
     309,   -14,  -518,  -518,  -518,  -518,  -518,  -518,  -518,    15,
    -518,   293,   -14,  -518,   387,  -518,   313,   320,   373,   -14,
     282,  -518,  -518,   319,  -518,  -518,  -518,   -14,  -518,   318,
     323,  -518,  -518,  -518,    82,   258,   239,  -518,  -518,   106,
     -14,  -518,  -518,    87,   -14,    87,    87,   324,    87,   325,
     317,   326,  -518,   250,  -518,  -518,    87,  -518,    87,    87,
      87,    87,    87,  -518,  -518,  -518,  -518,   288,    87,  -518,
     -14,   -14,   847,  -518,   268,  -518,     2,  -518,  -518,  -518,
    -518,    87,    87,    87,    87,    87,    87,    87,   392,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,   -14,  -518,
     -14,   -14,  -518,   -14,  -518,   -14,   -14,   256,  -518,    87,
      87,    87,    87,    87,  -518,  -518,   -14,   375,   394,    58,
    -518,     4,   -14,  -518,   681,  -518,  -518,  -518,  -518,  -518,
    -518,    -3,  -518,   385,   -14,   -14,    87,    87,    87,    87,
      87,    87,    87,   334,  -518,   333,   335,   336,   337,  -518,
     318,    12,   338,   339,   341,   357,   359,  -518,   -14,   360,
    -518,  -518,   363,  -518,  -518,  -518,   362,   364,  -518,    34,
    -518,   -14,  -518,   -14,   388,   385,  -518,   365,    78,   372,
     374,   376,   381,   389,   390,   391,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,   418,  -518,   760,
    -518,  -518,    87,    87,  -518,   182,  -518,  -518,  -518,  -518,
      83,    18,   -14,   322,  -518,  -518,   -14,  -518,    87,    87,
      87,    87,    87,    87,    87,   202,   -14,   367,    87,   156,
     452,  -518,  -518,  -518,   395,   295,    87,    87,  -518,   352,
    -518,  -518,  -518,   120,   -14,   -14,   -14,    87,    87,    87,
      87,  -518,  -518,  -518,   156,   108,   112,   240,  -518,   315,
     315,   315,   108,   315,   315,   315,   315,   315,   108,   108,
     108,   156,   156,   -18,  -518,   -14,    22,  -518,  -518,  -518,
     -14,    87,   156,  -518,  -518,   399,   404,   407,   413,   415,
     416,   419,   110,  -518,  -518,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,   408,  -518,  -518,   423,   447,  -518,
    -518,   414,  -518,  -518,   301,   410,   312,  -518,    -6,   156,
     156,  -518,   -14,   433,  -518,   321,   462,  -518,   292,   156,
     135,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,   101,
     101,   101,   101,  -518,   101,   101,   101,   101,  -518,   101,
     101,  -518,   101,   101,   101,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,   441,  -518,   422,  -518,   433,   -14,   -14,
     -14,   458,   321,  -518,  -518,  -518,   140,  -518,   296,  -518,
    -518,   209,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,   -14,   -14,   -14,
     -14,   -14,   -14,   465,   458,  -518,  -518,  -518,   161,  -518,
     296,  -518,   425,   -14,   427,   428,   429,   515,   -14,  -518,
     470,   465,  -518,  -518,  -518,  -518,   166,   -14,  -518,  -518,
    -518,  -518,  -518,   -20,   433,   -14,   471,   470,  -518,  -518,
    -518,   431,   -17,  -518,    51,   -14,   316,  -518,   471,  -518,
    -518,   -14,  -518,  -518,   -14,   433,  -518,   -14,  -518,   445,
     443,  -518,  -518,   -14,  -518,   -14,  -518,   -14,   -14,  -518,
    -518,  -518,  -518
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -518,  -518,  -518,  -518,  -518,  -518,  -518,   513,  -518,   454,
    -518,  -518,  -518,   420,  -518,   346,  -518,  -518,  -518,   298,
     -73,  -518,  -518,  -518,   195,  -518,   158,  -518,   134,  -518,
    -518,  -518,   251,  -194,  -167,  -518,  -518,  -518,  -518,  -518,
     421,  -518,  -518,  -166,  -518,   -22,  -518,   203,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,   274,  -147,  -518,
    -518,   183,  -518,  -518,  -386,  -518,  -518,  -518,  -518,  -518,
    -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -518,  -101,
     -67,  -518,  -244,  -518,  -518,   114,  -518,  -518,    65,  -518,
    -518,  -518,   -29,  -518,  -518,   -44,  -518,  -518,   -54,  -518,
    -518,    23,  -518,  -518,     1,  -518,  -340,  -451,  -518,  -260,
    -236,   -75,  -200,  -160,   444,  -518,  -518,  -518,   -16,    -7,
    -151,  -287,   -61,  -518,   424,  -518,    -1,  -518,  -517,   -53,
    -518,  -518,  -518,  -518,  -518,  -104,  -518,   509,  -193,  -518,
     400,  -518,  -518,  -518,  -165,  -518,  -518,  -518,  -518,   464
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -189
static const yytype_int16 yytable[] =
{
       8,   124,   213,   308,   126,   176,   256,   215,   338,    68,
     558,   294,    73,    74,    75,    76,    77,    78,    79,    84,
     153,   161,   120,   153,   141,   120,   162,   145,   452,   309,
     118,   163,   435,   104,   164,   165,   120,     7,   286,     1,
     330,   362,   363,   166,   370,   477,   478,     7,   167,    85,
     189,   479,   480,   168,     7,    80,   490,     7,   132,   133,
       7,     7,   208,   479,   480,   287,   288,   290,   111,   483,
     481,     7,   105,   602,   123,   123,   613,   604,    81,    84,
      84,   141,   357,   331,   144,   369,   521,   146,   295,   403,
     286,     9,   325,   522,   523,   112,   214,   125,   625,   351,
      69,   119,   223,   536,   174,    10,   393,   573,   574,   575,
     576,   177,   194,   195,   196,   197,   198,   287,   288,   290,
     129,   130,   588,   460,   123,     7,   412,    97,   461,   241,
     242,   243,     7,    84,    84,    84,    84,    84,   453,   454,
     455,   144,   603,     7,   615,   323,   244,   245,   246,   247,
     207,   211,     7,   616,   617,    85,   201,     7,   137,   138,
     222,     7,   140,   624,   215,   377,   626,   415,   217,   218,
     392,   226,   629,    85,   630,   212,   631,   632,   236,   479,
     480,    86,    87,   103,   456,   457,   239,   538,    32,   362,
     363,   310,   256,   248,     7,    86,    87,   109,   498,   257,
     416,   417,   418,   259,   479,   480,   110,   444,   326,   479,
     480,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   537,   431,   241,   242,   243,   567,   280,
     281,   134,   135,   136,   120,   212,   161,   128,   137,   138,
     212,   162,   244,   245,   246,   247,   163,   432,   584,   164,
     165,   462,   148,   600,   193,   387,   463,   305,   166,   306,
     307,     7,   211,   167,   211,   123,   619,   153,   168,   134,
     135,   136,   186,    85,   187,   317,   137,   138,   324,   627,
     140,   327,    64,   212,    32,    65,   139,    10,   179,   411,
     332,    69,   105,   337,   280,   570,   231,   291,   394,   539,
     539,   539,   539,   173,   539,   539,   539,   539,   134,   539,
     539,   112,   539,   539,   539,   137,   138,   211,   464,   465,
     466,   467,   469,   470,   471,   472,   473,   134,   125,   136,
     280,   188,   371,   187,   137,   138,   267,   324,   268,   540,
     540,   540,   540,   185,   540,   540,   540,   540,   191,   540,
     540,   622,   540,   540,   540,   468,   372,   192,   396,   397,
     203,   474,   475,   476,   205,   488,   515,   516,   517,   324,
     212,   395,   528,   529,   530,   280,   275,   519,   276,   520,
     535,   225,   187,   439,   440,   211,   206,   569,   396,   397,
     571,   456,   457,   216,    64,   618,   219,   220,   221,   228,
     229,   231,   324,   445,   446,   447,   230,   238,   187,   318,
     265,   240,   262,   264,   303,   266,   320,   585,   333,   569,
     346,   347,   372,   348,   349,   350,   352,   353,    13,   354,
      14,    15,    16,    17,   482,   585,    18,    19,    20,   123,
      21,    22,    23,    24,    25,   355,    26,   356,   358,   359,
     360,   376,   361,   386,   413,   105,    27,    28,    29,    30,
      31,   378,   435,   379,   503,   380,    93,    94,    95,    96,
     381,    98,    99,   100,   101,   102,   511,   518,   382,   383,
     384,   525,  -188,   438,   545,   546,   547,   491,   548,   549,
     550,   551,   492,   552,   553,   493,   554,   555,   556,    32,
      33,   494,    34,   495,   496,    35,   508,   497,   526,   483,
     479,   557,   562,   578,   587,   589,   590,   591,   592,   595,
     611,   606,   618,    64,    70,   113,   237,   559,   560,   561,
     375,   398,   292,   443,   147,   328,   182,   149,   150,   151,
     152,   311,   156,   157,   158,   159,   160,   190,   391,   385,
     484,   534,   599,   610,   621,   566,   572,   525,   525,   525,
     525,   577,   183,   586,   184,   583,   202,   628,   107,   224,
     175,     0,   525,     0,     0,     0,     0,   594,     0,     0,
       0,     0,     0,     0,     0,     0,   601,     0,     0,     0,
       0,     0,   525,     0,   605,     0,     0,     0,     0,     0,
       0,   614,     0,   525,   525,     0,     0,     0,     0,     0,
     211,     0,     0,   525,     0,     0,   525,     0,     0,     0,
       0,     0,   525,     0,   525,     0,   525,   525,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   258,     0,   260,
     261,     0,   263,     0,     0,     0,     0,     0,     0,     0,
     269,     0,   270,   271,   272,   273,   274,     0,     0,     0,
       0,     0,   277,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   296,   297,   298,   299,   300,
     301,   302,    13,     0,    14,    15,    16,    17,     0,     0,
      18,    19,    20,     0,    21,    22,    23,    24,    25,     0,
      26,     0,     0,   312,   313,   314,   315,   316,     0,   105,
      27,    28,    29,    30,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     339,   340,   341,   342,   343,   344,   345,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,   282,    34,     0,     0,   283,
       0,    13,     0,    14,    15,    16,    17,     0,     0,    18,
      19,    20,     0,    21,    22,    23,    24,    25,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
      28,    29,    30,    31,     0,     0,   388,   389,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,   410,     0,
       0,     0,   414,     0,     0,     0,     0,     0,     0,     0,
     441,   442,    32,    33,     0,    34,     0,     0,    35,     0,
       0,   448,   449,   450,   451,     0,     0,     0,    13,     0,
      14,    15,    16,    17,     0,     0,    18,    19,    20,     0,
      21,    22,    23,    24,    25,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,   489,    27,    28,    29,    30,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,   282,    34,     0,     0,   283
};

static const yytype_int16 yycheck[] =
{
       1,    76,   153,   263,    77,   109,   199,   154,   295,    10,
     527,     9,    13,    14,    15,    16,    17,    18,    19,    20,
      11,     6,    18,    11,    85,    18,    11,    88,   414,   265,
      17,    16,    10,    34,    19,    20,    18,    74,   232,    80,
     284,     7,     8,    28,   331,   431,   432,    74,    33,    86,
     125,    69,    70,    38,    74,    68,   442,    74,    80,    81,
      74,    74,    89,    69,    70,   232,   232,   232,    69,    47,
      88,    74,    38,    93,    75,    76,    93,   594,    91,    80,
      81,   142,   318,    86,    85,   329,    92,    88,    86,   376,
     284,     0,    88,   479,   480,     5,    87,    90,   615,    87,
      10,    88,    87,   489,   105,     6,    88,   558,   559,   560,
     561,   112,   134,   135,   136,   137,   138,   284,   284,   284,
      72,    73,   573,    11,   125,    74,   386,    86,    16,    23,
      24,    25,    74,   134,   135,   136,   137,   138,    30,    31,
      32,   142,   593,    74,    93,    87,    40,    41,    42,    43,
     151,   152,    74,   604,   605,    86,    87,    74,    76,    77,
     161,    74,    93,   614,   311,    87,   617,    11,    88,    89,
      87,   172,   623,    86,   625,    74,   627,   628,   179,    69,
      70,    94,    95,    86,    76,    77,   187,    86,    82,     7,
       8,   266,   385,    87,    74,    94,    95,    86,    88,   200,
      44,    45,    46,   204,    69,    70,    88,    87,   281,    69,
      70,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    88,    68,    23,    24,    25,    88,   230,
     231,    69,    70,    71,    18,    74,     6,    88,    76,    77,
      74,    11,    40,    41,    42,    43,    16,    91,    87,    19,
      20,    11,    93,    87,    92,   359,    16,   258,    28,   260,
     261,    74,   263,    33,   265,   266,   606,    11,    38,    69,
      70,    71,    88,    86,    90,   276,    76,    77,   279,   619,
      93,   282,    78,    74,    82,    81,    86,     6,     6,    87,
     291,    10,    38,   294,   295,    86,    28,    29,   371,   499,
     500,   501,   502,    88,   504,   505,   506,   507,    69,   509,
     510,     5,   512,   513,   514,    76,    77,   318,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    69,    90,    71,
     331,    88,   333,    90,    76,    77,    86,   338,    88,   499,
     500,   501,   502,    88,   504,   505,   506,   507,    88,   509,
     510,   611,   512,   513,   514,   422,    34,    88,    36,    37,
      89,   428,   429,   430,    89,   440,    65,    66,    67,   370,
      74,   372,    51,    52,    53,   376,    88,    65,    90,    67,
      88,    88,    90,    88,    89,   386,    89,   538,    36,    37,
     541,    76,    77,    89,    78,    79,    89,    89,    89,    12,
      87,    28,   403,   404,   405,   406,    86,    88,    90,    34,
      93,    88,    88,    88,    22,    89,    22,   568,    33,   570,
      86,    88,    34,    88,    88,    88,    88,    88,    11,    88,
      13,    14,    15,    16,   435,   586,    19,    20,    21,   440,
      23,    24,    25,    26,    27,    88,    29,    88,    88,    86,
      88,    86,    88,    35,    87,    38,    39,    40,    41,    42,
      43,    89,    10,    89,    56,    89,    22,    23,    24,    25,
      89,    27,    28,    29,    30,    31,    62,    67,    89,    89,
      89,   482,    59,    88,   500,   501,   502,    88,   504,   505,
     506,   507,    88,   509,   510,    88,   512,   513,   514,    82,
      83,    88,    85,    88,    88,    88,    59,    88,    75,    47,
      69,    89,    54,    48,    89,    88,    88,    88,     3,    49,
      89,    50,    79,    78,    11,    71,   180,   528,   529,   530,
     335,   373,   234,   399,    90,   284,   116,    93,    94,    95,
      96,   267,    98,    99,   100,   101,   102,   126,   365,   346,
     436,   486,   581,   597,   608,   532,   557,   558,   559,   560,
     561,   562,   118,   570,   120,   564,   142,   620,    59,   169,
     106,    -1,   573,    -1,    -1,    -1,    -1,   578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   587,    -1,    -1,    -1,
      -1,    -1,   593,    -1,   595,    -1,    -1,    -1,    -1,    -1,
      -1,   602,    -1,   604,   605,    -1,    -1,    -1,    -1,    -1,
     611,    -1,    -1,   614,    -1,    -1,   617,    -1,    -1,    -1,
      -1,    -1,   623,    -1,   625,    -1,   627,   628,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,
     206,    -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,   218,   219,   220,   221,   222,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,   245,
     246,   247,    11,    -1,    13,    14,    15,    16,    -1,    -1,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,    -1,
      29,    -1,    -1,   269,   270,   271,   272,   273,    -1,    38,
      39,    40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,   297,   298,   299,   300,   301,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    88,
      -1,    11,    -1,    13,    14,    15,    16,    -1,    -1,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    -1,    -1,   362,   363,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   378,   379,   380,   381,   382,   383,   384,    -1,
      -1,    -1,   388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     396,   397,    82,    83,    -1,    85,    -1,    -1,    88,    -1,
      -1,   407,   408,   409,   410,    -1,    -1,    -1,    11,    -1,
      13,    14,    15,    16,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    26,    27,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   441,    39,    40,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    80,    97,    98,    99,   238,   239,    74,   232,     0,
       6,   102,   103,    11,    13,    14,    15,    16,    19,    20,
      21,    23,    24,    25,    26,    27,    29,    39,    40,    41,
      42,    43,    82,    83,    85,    88,   129,   130,   131,   132,
     133,   134,   135,   137,   139,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   237,   241,   242,
     243,   244,   250,   253,    78,    81,   212,   240,   232,    10,
     103,   104,   105,   232,   232,   232,   232,   232,   232,   232,
      68,    91,   141,   142,   232,    86,    94,    95,   218,   219,
     220,   228,   232,   220,   220,   220,   220,    86,   220,   220,
     220,   220,   220,    86,   232,    38,   188,   243,   255,    86,
      88,   232,     5,   105,   106,   107,   108,   109,    17,    88,
      18,   116,   217,   232,   217,    90,   116,   136,    88,    72,
      73,   138,   141,   141,    69,    70,    71,    76,    77,    86,
      93,   228,   229,   230,   232,   228,   232,   220,    93,   220,
     220,   220,   220,    11,   163,   164,   220,   220,   220,   220,
     220,     6,    11,    16,    19,    20,    28,    33,    38,   245,
     246,   247,   248,    88,   232,   255,   241,   232,   100,     6,
     110,   111,   109,   220,   220,    88,    88,    90,    88,   217,
     136,    88,    88,    92,   141,   141,   141,   141,   141,   143,
     231,    87,   230,    89,   221,    89,    89,   232,    89,   215,
     216,   232,    74,   226,    87,   164,    89,    88,    89,    89,
      89,    89,   232,    87,   246,    88,   232,   249,    12,    87,
      86,    28,   112,   113,   114,   115,   232,   111,    88,   232,
      88,    23,    24,    25,    40,    41,    42,    43,    87,   144,
     145,   146,   147,   148,   149,   150,   244,   232,   220,   232,
     220,   220,    88,   220,    88,    93,    89,    86,    88,   220,
     220,   220,   220,   220,   220,    88,    90,   220,   251,   227,
     232,   232,    84,    88,   127,   128,   129,   130,   139,   236,
     250,    29,   115,   117,     9,    86,   220,   220,   220,   220,
     220,   220,   220,    22,   140,   232,   232,   232,   215,   216,
     217,   163,   220,   220,   220,   220,   220,   232,    34,   189,
      22,   252,   254,    87,   232,    88,   116,   232,   128,   187,
     188,    86,   232,    33,   118,   119,   120,   232,   227,   220,
     220,   220,   220,   220,   220,   220,    86,    88,    88,    88,
      88,    87,    88,    88,    88,    88,    88,   216,    88,    86,
      88,    88,     7,     8,   165,   166,   167,   168,   169,   188,
     227,   232,    34,   121,   122,   120,    86,    87,    89,    89,
      89,    89,    89,    89,    89,   143,    35,   241,   220,   220,
     101,   167,    87,    88,   116,   232,    36,    37,   122,   123,
     124,   125,   126,   227,   220,   220,   220,   220,   220,   220,
     220,    87,   215,    87,   220,    11,    44,    45,    46,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    68,    91,   170,   171,    10,   190,   191,    88,    88,
      89,   220,   220,   124,    87,   232,   232,   232,   220,   220,
     220,   220,   170,    30,    31,    32,    76,    77,   185,   186,
      11,    16,    11,    16,   185,   185,   185,   185,   186,   185,
     185,   185,   185,   185,   186,   186,   186,   170,   170,    69,
      70,    88,   232,    47,   191,   192,   193,   194,   217,   220,
     170,    88,    88,    88,    88,    88,    88,    88,    88,   181,
     183,   182,   184,    56,   172,   173,   174,   175,    59,   176,
     177,    62,   178,   179,   180,    65,    66,    67,    67,    65,
      67,    92,   170,   170,   213,   232,    75,   234,    51,    52,
      53,   205,   206,   207,   194,    88,   170,    88,    86,   218,
     219,   222,   223,   224,   226,   224,   224,   224,   224,   224,
     224,   224,   224,   224,   224,   224,   224,    89,   234,   232,
     232,   232,    54,   208,   209,   210,   207,    88,   225,   226,
      86,   226,   232,   213,   213,   213,   213,   232,    48,   195,
     196,   197,   198,   210,    87,   226,   225,    89,   213,    88,
      88,    88,     3,   233,   232,    49,   199,   200,   201,   198,
      87,   232,    93,   213,   234,   232,    50,   202,   203,   204,
     201,    89,   214,    93,   232,    93,   213,   213,    79,   212,
     235,   204,   215,   211,   213,   234,   213,   212,   235,   213,
     213,   213,   213
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1455 of yacc.c  */
#line 150 "policy_parse.y"
    { if (define_policy(pass, 0) == -1) return -1; }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 152 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 155 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 163 "policy_parse.y"
    {if (define_class()) return -1;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 169 "policy_parse.y"
    {if (define_initial_sid()) return -1;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 180 "policy_parse.y"
    {if (define_common_perms()) return -1;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 186 "policy_parse.y"
    {if (define_av_perms(FALSE)) return -1;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 188 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 190 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 201 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 203 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 208 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 210 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 219 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 221 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 227 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 229 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 238 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 241 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 270 "policy_parse.y"
    { if (define_attrib()) return -1;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 273 "policy_parse.y"
    {if (define_type(1)) return -1;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 275 "policy_parse.y"
    {if (define_type(0)) return -1;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 278 "policy_parse.y"
    {if (define_typealias()) return -1;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 281 "policy_parse.y"
    {if (define_typeattribute()) return -1;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 284 "policy_parse.y"
    {if (define_typebounds()) return -1;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 290 "policy_parse.y"
    {if (define_bool()) return -1;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 293 "policy_parse.y"
    { if (insert_id("T",0)) return -1; }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 295 "policy_parse.y"
    { if (insert_id("F",0)) return -1; }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 298 "policy_parse.y"
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[(2) - (6)].ptr), (avrule_t*)(yyvsp[(4) - (6)].ptr), (avrule_t*)(yyvsp[(6) - (6)].ptr)) < 0) return -1;  }}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 301 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(3) - (4)].ptr); }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 303 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 305 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(2) - (3)].ptr);}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 307 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[(2) - (2)].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 310 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 313 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 316 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 319 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 322 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 325 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 328 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 332 "policy_parse.y"
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[(1) - (2)].ptr), (avrule_t *)(yyvsp[(2) - (2)].ptr)); }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 334 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 337 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 339 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 341 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 344 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 347 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 350 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 354 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 356 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 358 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 360 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 363 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 367 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 371 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 375 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 379 "policy_parse.y"
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 381 "policy_parse.y"
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 383 "policy_parse.y"
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 386 "policy_parse.y"
    { if (define_range_trans(0)) return -1; }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 388 "policy_parse.y"
    { if (define_range_trans(1)) return -1; }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 397 "policy_parse.y"
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 400 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 403 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 406 "policy_parse.y"
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 409 "policy_parse.y"
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 412 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 414 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 419 "policy_parse.y"
    {if (define_role_trans()) return -1; }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 422 "policy_parse.y"
    {if (define_role_allow()) return -1; }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 425 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 427 "policy_parse.y"
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[(1) - (2)].ptr), (role_datum_t*)(yyvsp[(2) - (2)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 430 "policy_parse.y"
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 432 "policy_parse.y"
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[(4) - (5)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 444 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 447 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 450 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(2) - (3)].valptr); }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 452 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[(2) - (2)].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 455 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 458 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 461 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 464 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 467 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 470 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 472 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 473 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 475 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 476 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 478 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 479 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 481 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 482 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 484 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 485 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 487 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 488 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 490 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 491 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 493 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 494 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 496 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 497 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 500 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 502 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 503 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 505 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 506 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 509 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (2)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 511 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 512 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 514 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 515 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 518 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 521 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 524 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 527 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 530 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 533 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 537 "policy_parse.y"
    { (yyval.valptr) = CEXPR_EQ; }
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 539 "policy_parse.y"
    { (yyval.valptr) = CEXPR_NEQ; }
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 542 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 544 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOM; }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 546 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOMBY; }
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 548 "policy_parse.y"
    { (yyval.valptr) = CEXPR_INCOMP; }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 554 "policy_parse.y"
    {if (define_user()) return -1;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 563 "policy_parse.y"
    {if (define_initial_sid_context()) return -1;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 572 "policy_parse.y"
    {if (define_fs_context((yyvsp[(2) - (5)].val),(yyvsp[(3) - (5)].val))) return -1;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 583 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (4)].val),(yyvsp[(3) - (4)].val))) return -1;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 585 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (6)].val),(yyvsp[(5) - (6)].val))) return -1;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 594 "policy_parse.y"
    {if (define_netif_context()) return -1;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 603 "policy_parse.y"
    {if (define_ipv4_node_context()) return -1;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 605 "policy_parse.y"
    {if (define_ipv6_node_context()) return -1;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 614 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 616 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 618 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 627 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 628 "policy_parse.y"
    {insert_id("-", 0);}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 629 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 631 "policy_parse.y"
    {if (define_genfs_context(0)) return -1;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 634 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 642 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 644 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 647 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 649 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 659 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 661 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 663 "policy_parse.y"
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 666 "policy_parse.y"
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 669 "policy_parse.y"
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 671 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 672 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 675 "policy_parse.y"
    { if (insert_id("~", 1)) return -1; }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 678 "policy_parse.y"
    { if (insert_id("*", 1)) return -1; }
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 690 "policy_parse.y"
    { if (insert_id(yytext, 1)) return -1; }
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 699 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 702 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 705 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 708 "policy_parse.y"
    { (yyval.val) = strtoul(yytext,NULL,0); }
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 711 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 714 "policy_parse.y"
    {if (define_polcap()) return -1;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 717 "policy_parse.y"
    {if (define_permissive()) return -1;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 722 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 727 "policy_parse.y"
    { if (define_policy(pass, 1) == -1) return -1; }
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 730 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 754 "policy_parse.y"
    { if (require_class(pass)) return -1; }
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 756 "policy_parse.y"
    { (yyval.require_func) = require_role; }
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 757 "policy_parse.y"
    { (yyval.require_func) = require_type; }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 758 "policy_parse.y"
    { (yyval.require_func) = require_attribute; }
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 759 "policy_parse.y"
    { (yyval.require_func) = require_user; }
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 760 "policy_parse.y"
    { (yyval.require_func) = require_bool; }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 761 "policy_parse.y"
    { (yyval.require_func) = require_sens; }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 762 "policy_parse.y"
    { (yyval.require_func) = require_cat; }
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 765 "policy_parse.y"
    { if ((yyvsp[(0) - (1)].require_func) (pass)) return -1; }
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 767 "policy_parse.y"
    { if ((yyvsp[(0) - (3)].require_func) (pass)) return -1; }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 770 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 772 "policy_parse.y"
    { if (end_optional(pass) == -1) return -1; }
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 775 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 779 "policy_parse.y"
    { if (begin_optional(pass) == -1) return -1; }
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 782 "policy_parse.y"
    { if (begin_optional_else(pass) == -1) return -1; }
    break;



/* Line 1455 of yacc.c  */
#line 3515 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



